/* $Id$

This file is part of gldbg
Copyright © 2009  Mikko Rasa, Mikkosoft Productions
Distributed under the GPL
*/

#ifndef GLPRINT_H_
#define GLPRINT_H_

#include "gldecoder.h"

#ifdef __cplusplus
extern "C" {
#endif

GlDecoder *glprint_new(char *, unsigned);
char *glprint_get_buffer(GlDecoder *);

#ifdef __cplusplus
}

class GlPrint
{
private:
	GlDecoder *glp;

public:
	GlPrint(char *b, unsigned l): glp(glprint_new(b, l)) { }
	~GlPrint() { gldecoder_delete(glp); }

	int decode(const char *d, unsigned l) { return gldecoder_decode(glp, d, l); }
	char *get_buffer() { return glprint_get_buffer(glp); }
};
#endif

#endif
